/**
 * @packageDocumentation
 * utilize http consistently across browser and node
 */
//import * as _imports from "./_imports"
// // eslint-disable-next-line @rushstack/typedef-var
// export const _gaxios = _imports.gaxios
//const _gaxios2 = _imports.gaxios
import { gaxios } from "./_imports";
export { gaxios };
// const func = async () => {
// 	return gaxios.request( { url: "" } )
// }
// /** access to 3rd party libraries selected for use by `xlib` */
// export namespace _internal {
// 	/**
// 	 * Seems the best isomorphic candidates are `gaxios` and `ky`.  No bugs found in `gaxios` so that's the choice.
// 	 * <!-- -->
// 	 * 
// 	 * right now, `ky` has a bug where ReadableStreams do not work in NodeJs.
// 	 * For example, you can not call `body.GetReader()`.
// 	 * A bug has been filed and accepted in the `ky` project for this, but if
// 	 * we need an alternatie project, can consider:
// 	 * - https://www.npmjs.com/package/isomorphic-unfetch
// 	 * - https://github.com/lquixada/cross-fetch
// 	 * - https://github.com/googleapis/gaxios
// 	 * - https://github.com/sindresorhus/ky
// 	 * 
// 	 * ideas from this thread:  https://github.com/request/request/issues/3142
// 	 */
// 	export const _README = null
// 	/** see {@link _imports.gaxios} ok */
// 	export const gaxios = _gaxios
// 	/** # TITLE
// 	 * 
// 	 * becakse, see
// 	 * 
// 	 * - this is working?
// 	 * @summary
// 	 *   - ***shmaybe***
// 	 * 
// 	 * @remarks
// 	 becakse, see
// 	 - this is working?
// 		 - ***shmaybe***
// 		*/
// 	export const gaxios2 = _gaxios2
// }
//import Bluebird from "bluebird";
import * as promise from "./promise";
import * as _ from "lodash";
import * as exception from "./exception";
import * as diagnostics from "./diagnostics";
const log = new diagnostics.Logger(__filename);
// 	520: Unknown Error:  any otherwise unhandled network issues will be returned as this
// 	522: Connection Timed Out:  could not connect to the server
// 	523: Origin Is Unreachable, ex:  DNS record not found
// 	524: A Timeout Occurred, requestOptions.timeout excceeded so request was aborted
/**
*  define a remote http endpoint for reuse in your application
* includes retry logic and exponential backoff.
*/
export class RemoteHttpEndpoint {
    constructor(
    /** default options that will be applied to all requests.  may be overridden by each actual .post() or .get() call */
    defaultOptions = {}) {
        this.defaultOptions = defaultOptions;
        this._onTooBusy = [];
        const defaults = {
            // preRetryErrorIntercept: ( async ( err: gaxios.GaxiosError<ANY> ) => {
            // 	if ( err.response != null && err.response.status <= 499 ) {
            // 		//console.assert(false, "err");
            // 		return "ABORT"
            // 	}
            // 	return "RETRY"
            // } ),
            // endpoint: { path: "" },
            // retryOptions: {
            // 	throw_original: true,
            // },
            // requestOptions: {
            // 	timeout: 60000,
            // 	headers: {
            // 		/** by default allow server to send a compressed response */
            // 		"Accept-Encoding": "gzip, deflate"
            // 	} as ANY,
            // },
            // responseInspector: ( result ) => {
            // 	if ( result.)
            //  },
            responseInspector: async (result) => {
                if (result.err !== null)
                    return "RETRY";
                if (result.response.status > 499)
                    return "RETRY";
                return "OK";
            }
        };
        this.defaultOptions = _.defaultsDeep({}, defaultOptions, defaults);
        if (this.defaultOptions.autoscalerOptions != null) {
            this._autoscaler = new promise.Autoscaler(this.defaultOptions.autoscalerOptions, this._doRequest_send.bind(this), (err) => {
                var _a;
                if (err instanceof gaxios.GaxiosError) {
                    switch ((_a = err === null || err === void 0 ? void 0 : err.response) === null || _a === void 0 ? void 0 : _a.status) {
                        case 503:
                        case 429:
                            //notify listeners
                            if (this._onTooBusy.length > 0) {
                                this._onTooBusy.forEach((fcn) => { fcn(this); });
                            }
                            return "TOO_BUSY";
                    }
                }
                return "FAIL";
            });
        }
        this._gaxios = new gaxios.Gaxios(this.defaultOptions.requestOptions);
    } //end .ctor()
    toJson() {
        var _a;
        return { options: this.defaultOptions, autoscaler: (_a = this._autoscaler) === null || _a === void 0 ? void 0 : _a.toJson() };
    }
    post(
    /** pass a payload to POST */
    submitPayload, 
    /**override any default options if desired */
    overrideOptions) {
        return this._doRequest("post", submitPayload, overrideOptions);
    }
    get(
    /** pass a payload to POST */
    //submitPayload: TSubmitPayload,
    /**override any default options if desired */
    overrideOptions) {
        return this._doRequest("get", undefined, overrideOptions);
    }
    async _doRequest(protocol, 
    /** pass a payload to POST */
    submitPayload, 
    /**override defaults */
    overrideOptions = {}) {
        log.debug({ protocol }, "EzEndpoint._doRequest() called");
        //copy parameters from our overrides, in an additive manner, allowing for example, customizing the origin while keeping the default path.
        const finalOptions = _.defaultsDeep({}, overrideOptions, this.defaultOptions);
        if (finalOptions.endpoint.origin == null || finalOptions.endpoint.path == null) {
            //log.error( { endpoint: finalOptions.endpoint }, "can not make endpoint request.  missing required endpoint options.  need both origin and path specified." )
            throw new exception.XlibException("can not make endpoint request.  missing required endpoint options.  need both origin and path specified.", { details: { endpoint: finalOptions.endpoint } });
        }
        const endpoint = finalOptions.endpoint.origin + finalOptions.endpoint.path;
        // if ( protocol === "get" && submitPayload != null ) {
        // 	//throw log.error( { protocol, finalOptions, submitPayload }, "EzEndpoint._doRequest() submit payload was passed to a GET request, this is not supported by Axios and most endpoints" )
        // 	throw new diag.exception.XlibException( "EzEndpoint._doRequest() submit payload was passed to a GET request, this is not supported by Axios and most endpoints", { details: { protocol, finalOptions, submitPayload } } )
        // }
        if (this._autoscaler == null) {
            return this._doRequest_send(finalOptions, endpoint, protocol, submitPayload);
        }
        else {
            return this._autoscaler.submitRequest(finalOptions, endpoint, protocol, submitPayload);
        }
    }
    async _doRequest_send(finalOptions, endpoint, protocol, submitPayload) {
        const requestOptions = Object.assign(Object.assign({}, finalOptions.requestOptions), { url: endpoint, method: protocol.toUpperCase(), body: submitPayload });
        const result = await promise.retry(finalOptions.retryOptions, async () => {
            log.debug("EzEndpoint._doRequest() in promise.retry block");
            const result = await this._gaxios.request(requestOptions)
                .then((response) => {
                return { response };
            }, (err) => {
                return { err };
            });
            log.debug("EzEndpoint._doRequest() got valid response");
            if (finalOptions.responseInspector != null) {
                const decision = await finalOptions.responseInspector(result);
                switch (decision) {
                    case "RETRY":
                        return Promise.reject(result);
                    case "OK":
                        return Promise.resolve(result);
                    case "ABORT":
                        return Promise.reject(new promise.RetryStopError("ABORT by responseInspector()"));
                }
            }
            return result;
        });
        if (result.err != null) {
            return Promise.reject(result.err);
        }
        return Promise.resolve(result.response);
    }
}
//# sourceMappingURL=net.js.map