/** general purpose shape of an enum */
interface IEnum<T> {
    [key: string]: T | string;
    [nu: number]: string;
}
/**
 * parse a string or num into an enum value.  Designed for "standard" enums that map to numerical values.  not for string enums.
 * @remarks
 * for string enums, just do a keys lookup
 */
export declare function parseEnum<TEnum extends IEnum<T>, T>(enumClass: TEnum, key: (keyof TEnum) | string | number | undefined, { caseSensitive }?: {
    caseSensitive?: boolean | undefined;
}): TEnum[keyof TEnum] | undefined;
export {};
