import * as uuid from "uuid";
export { uuid };
import * as security from "../security";
import * as ex from "../diagnostics/exception";
/** create a deterministic guid (v4) by hashing string input.   If you want a random guid, use {@link uuid.v4() } */
export async function guidDeterministic(str) {
    if (!str || str.length < 1) { // no parameter supplied
        //return uuid.v4()          // return node-uuid v4() uuid
        throw new ex.XlibException("blank/null input.  creating a deterministic guid requires an input string");
    }
    else { // create a consistent (non-random!) UUID
        const hash = await security.hash(str.toString(), "SHA-256"); // crypto.createHash( "sha256" ).update( str.toString() ).digest( "hex" ).substring( 0, 36 )		
        const chars = hash.substring(0, 36).split("");
        chars[8] = "-";
        chars[13] = "-";
        chars[14] = "4";
        chars[18] = "-";
        chars[19] = "8";
        chars[23] = "-";
        const guid = chars.join("");
        return guid;
    }
}
//# sourceMappingURL=guid.js.map