"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.base64 = exports.base64Url = exports.intToIpV4 = exports.ipV4toInt = exports.stringToArrayBuffer = exports.arrayBufferToString = void 0;
const _ = __importStar(require("lodash"));
function arrayBufferToString(buffer) {
    return String.fromCharCode.apply(null, new Uint8Array(buffer));
}
exports.arrayBufferToString = arrayBufferToString;
function stringToArrayBuffer(str) {
    const buf = new ArrayBuffer(str.length * 2); // 2 bytes for each char
    const bufView = new Uint16Array(buf);
    for (let i = 0, strLen = str.length; i < strLen; i++) {
        bufView[i] = str.charCodeAt(i);
    }
    return buf;
}
exports.stringToArrayBuffer = stringToArrayBuffer;
function ipV4toInt(ip) {
    const parts = ip.split(".");
    let res = 0;
    res += parseInt(parts[0], 10) << 24;
    res += parseInt(parts[1], 10) << 16;
    res += parseInt(parts[2], 10) << 8;
    res += parseInt(parts[3], 10);
    return res;
}
exports.ipV4toInt = ipV4toInt;
function intToIpV4(int) {
    const part1 = int & 255;
    const part2 = ((int >> 8) & 255);
    const part3 = ((int >> 16) & 255);
    const part4 = ((int >> 24) & 255);
    // tslint:disable-next-line: restrict-plus-operands
    return part4 + "." + part3 + "." + part2 + "." + part1;
}
exports.intToIpV4 = intToIpV4;
const base64url_1 = __importDefault(require("base64url"));
/**
 *  Converting to, and from, base64url https://en.wikipedia.org/wiki/Base64#RFC_4648
example:   base64=```'qL8R4QIcQ/ZsRqOAbeRfcZhilN/MksRtDaErMA=='``` base64Url=```'qL8R4QIcQ_ZsRqOAbeRfcZhilN_MksRtDaErMA'```
uses the npm package: https://www.npmjs.com/package/base64url
 */
exports.base64Url = base64url_1.default;
//export const base64Url = _base64Url.default
/**
 *  base64 encode and decode functions
 */
// eslint-disable-next-line @typescript-eslint/no-namespace
var base64;
(function (base64) {
    function encode(input) {
        const isStr = _.isString(input);
        if (isStr !== true || (typeof (btoa) === "undefined" && typeof (Buffer) !== "undefined")) {
            if (isStr) {
                //nodejs does not define bota or atob
                return Buffer.from(input, "utf8").toString("base64");
            }
            else {
                return input.toString("base64");
            }
        }
        return btoa(input);
    }
    base64.encode = encode;
    function decode(base64Encoded) {
        if (typeof (atob) === "undefined" && typeof (Buffer) !== "undefined") {
            //nodejs does not define bota or atob
            return Buffer.from(base64Encoded, "base64").toString("utf8");
        }
        return atob(base64Encoded);
    }
    base64.decode = decode;
    function toBuffer(base64Encoded) {
        return Buffer.from(base64Encoded, "base64");
    }
    base64.toBuffer = toBuffer;
})(base64 = exports.base64 || (exports.base64 = {}));
//# sourceMappingURL=convert.js.map