"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deterministic = exports.uuid = void 0;
const security = __importStar(require("./security"));
const exception = __importStar(require("./exception"));
const uuid = __importStar(require("uuid"));
exports.uuid = uuid;
/** create a deterministic v4 guid by hashing string input.   If you want a random guid, use {@link uuid.v4() }
 *
 * **Important** defaults to using SHA-256. Output guids won't match if hashAlgo is different."
 */
async function deterministic(str, algoName = "SHA-256") {
    if (!str || str.length < 1) { // no parameter supplied
        //return uuid.v4()          // return node-uuid v4() uuid
        throw new exception.XlibException("blank/null input.  creating a deterministic guid requires an input string");
    }
    else { // create a consistent (non-random!) UUID
        //const hash = crypto.createHash( "sha256" ).update( str.toString() ).digest( "hex" ).substring( 0, 36 )
        const hash = await security.hash(str, algoName);
        const chars = hash.substring(0, 36).split("");
        chars[8] = "-";
        chars[13] = "-";
        chars[14] = "4";
        chars[18] = "-";
        chars[19] = "8";
        chars[23] = "-";
        const guid = chars.join("");
        return guid;
    }
}
exports.deterministic = deterministic;
//# sourceMappingURL=guid.js.map