"use strict";
/* eslint-disable no-inner-declarations */
/* eslint-disable @typescript-eslint/no-namespace */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseFunction = exports.jsonX = exports.dsv = void 0;
const reflection = __importStar(require("./reflection"));
const _ = __importStar(require("lodash"));
const stringHelper = __importStar(require("./str"));
const dsv = __importStar(require("d3-dsv"));
exports.dsv = dsv;
const time = __importStar(require("./time"));
const exception = __importStar(require("./exception"));
const json5 = __importStar(require("json5"));
//export const json5: JSON = _json5 as ANY
/** awesome json parse and stringify capabilities */
var jsonX;
(function (jsonX) {
    /** a forgiving JSON parser.  Allows for comments, unquoted keys, trailing commas, etc.   see: https://www.npmjs.com/package/json5
        *
                            * Converts a JavaScript Object Notation (JSON) string into an object.
                            * @param text A valid JSON string.
                            * @param reviver A function that transforms the results. This function is called for each member of the object.
                            * If a member contains nested objects, the nested objects are transformed before the parent object is.
                            */
    jsonX.parse = json5.parse.bind(json5); //  ( text: string, reviver?: ( key: ANY, value: ANY ) => ANY ) => ANY = json5.parse.bind( json5 );
    /** parses your object using ```json5```, then attempts to parse string values in your object.  failed parse() calls will return the original string for that variable */
    function parseRecursive(textOrObj, reviver) {
        if (typeof (textOrObj) === "string") {
            try {
                textOrObj = jsonX.parse(textOrObj, reviver);
            }
            catch (ex) {
                return textOrObj;
            }
        }
        _.forOwn(textOrObj, (value, key, obj) => {
            if (typeof (value) === "string") {
                obj[key] = parseRecursive(value, reviver);
            }
        });
        return textOrObj;
    }
    jsonX.parseRecursive = parseRecursive;
    function stringify(value, ...args) {
        let options;
        if (reflection.getType(args[0]) === reflection.Type.object) {
            options = args[0];
        }
        else {
            options = {
                replacer: args[0],
                space: _.defaultTo(args[1], "\t"),
                quote: args[2],
            };
        }
        return json5.stringify(value, options);
    }
    jsonX.stringify = stringify;
    function inspectStringify(obj, options) {
        const outputJson = inspectParse(obj, options);
        return JSON.stringify(outputJson, undefined, "  ");
    }
    jsonX.inspectStringify = inspectStringify;
    /** debug inspection helper. outputs human readable JSON (but won't round-trip with .parse()).  handles circular references gracefully */
    function inspectParse(obj, options) {
        options = Object.assign({ maxArrayElements: 10, maxDepth: 1, summarizeLength: 120 }, options);
        return _inspectParse_internal(obj, options, [], "");
    }
    jsonX.inspectParse = inspectParse;
    /** internal helper to do actual parse work */
    function _inspectParse_internal(obj, parentOptions, 
    /** for internal recursive use, tracking circular references. */
    parentSeenObjects, key) {
        const myOptions = _.clone(parentOptions);
        try {
            myOptions.maxDepth--;
            // ! circular reference detection
            /** cache of all objects to check for circular references.   see https://stackoverflow.com/questions/14962018/detecting-and-fixing-circular-references-in-javascript */
            const seenObjects = _.clone(parentSeenObjects);
            if (_.isObject(obj)) {
                if (parentSeenObjects.indexOf(obj) !== -1) {
                    return `[CIRCULAR REFERENCE type=${reflection.getTypeName(obj)}]`;
                }
                seenObjects.push(obj);
            }
            // ! output string value of node if possible
            const Type = reflection.Type;
            const type = reflection.getType(obj);
            //if it's well known types, generate friendly values
            const typeName = reflection.getTypeName(obj);
            if (myOptions.typeProcessor != null) {
                const customProcessorResult = myOptions.typeProcessor(obj, type, typeName, key, myOptions);
                if (customProcessorResult != null) {
                    return customProcessorResult;
                }
            }
            switch (type) {
                case Type.boolean:
                case Type.number:
                case Type.null:
                    return obj;
                case Type.symbol:
                    if (Symbol.keyFor(obj) != null) {
                        return obj.toString() + "[GLOBAL]";
                    }
                    else {
                        return obj.toString();
                    }
                case Type.undefined:
                    return "[UNDEFINED]";
                case Type.string:
                    return stringHelper.summarize(obj, myOptions.summarizeLength);
                case Type.Date:
                    {
                        const asDate = obj;
                        //	return asDate.toISOString();
                        //const ago = time.luxon.DateTime.fromJSDate( asDate ).until( time.luxon.DateTime.utc() ).toDuration().toFormat( "hh:mm:ss.SS" );
                        const diffNow = time.dayjs(asDate).diff(Date.now()); // .luxon.DateTime.fromMillis( asDate.valueOf() ).diffNow()
                        //let ago = diffNow.toISO();
                        //  let ago = diffNow.valueOf() < 0 ? "-" : "";
                        // ago += diffNow.toFormat( "hh:mm:ss.SS" );
                        const ago = time.dayjs.duration(diffNow).format("hh:mm:ss.SS");
                        // //numHelper.format((Date.now()-asDate.getTime())/1000)
                        return `${asDate.toISOString()} (deltaNow:${ago})`;
                    }
                case Type.Error: {
                    const errOptions = Object.assign(Object.assign({}, myOptions), { maxDepth: myOptions.maxDepth + 1 });
                    //retry using an error JSON
                    return _inspectParse_internal(exception.errorToJson(obj), errOptions, seenObjects, key);
                }
                case Type.function:
                    {
                        // eslint-disable-next-line @typescript-eslint/ban-types
                        const asFunction = obj;
                        let funcStr = asFunction.toString();
                        funcStr = stringHelper.removeAfter(funcStr, ")", true);
                        funcStr = "[FUNCTION " + stringHelper.removeBefore(funcStr, "function ") + "]";
                        return stringHelper.summarize(funcStr, myOptions.summarizeLength);
                    }
                case Type.RegExp:
                    {
                        const asRegEx = obj;
                        return stringHelper.summarize(asRegEx.toString(), myOptions.summarizeLength);
                    }
                case Type.classCtor:
                    return `[CLASS ${reflection.getTypeName(obj)}]`;
                default:
                    return `[INSPECT_TYPE_NOT_HANDLED  type=${Type[type]}]`;
                case Type.Array:
                case Type.object:
                    {
                        if (obj.asMilliseconds != null) {
                            //guess it's a duration object of some sort
                            const ms = obj.asMilliseconds();
                            return time.dayjs.duration(ms).format("hh:mm:ss.SS");
                        }
                        if (obj.toISOString != null && obj.year != null) {
                            //guess it's a date object of some sort
                            const asDate = time.dayjs(obj.toISOString());
                            const diffNow = time.dayjs.duration(asDate.diff(Date.now())); //time.luxon.DateTime.fromMillis( asDate.valueOf() ).diffNow()
                            const ago = diffNow.format("hh:mm:ss.SS");
                            return `${asDate.toISOString()} (deltaNow:${ago})`;
                        }
                        //handle specific known types
                        switch (typeName) {
                            // case "Duration":
                            // case "DateTime":
                            // 	if ( obj.valueOf != null ) {
                            // 		const asDate = new Date( obj.valueOf() )
                            // 		const diffNow = time.luxon.DateTime.fromMillis( asDate.valueOf() ).diffNow()
                            // 		//let ago = diffNow.toISO();
                            // 		// let ago = diffNow.valueOf() < 0 ? "-" : "";
                            // 		// ago += diffNow.toFormat( "hh:mm:ss.SS" );
                            // 		const ago = diffNow.toFormat( "hh:mm:ss.SS" )
                            // 		// //numHelper.format((Date.now()-asDate.getTime())/1000)
                            // 		return `${ asDate.toISOString() } (deltaNow:${ ago })`
                            // 	}
                            // 	break
                            case "Timeout":
                                return "[Timer Handle (typename=\"Timeout\")]";
                        }
                        //for other object cases, we need to recursively walk them.   see below
                        break;
                    }
            }
            // ! the obj is an array, or object
            if (myOptions.maxDepth < 0) {
                //at max depth.  output typename
                if (type === Type.Array) {
                    const asArray = obj;
                    return `[ARRAY len=${asArray.length}]`;
                }
                else {
                    return `[OBJECT typeName="${reflection.getTypeName(obj)}"]`;
                }
            }
            const testMap = new Map();
            const testSet = new Set();
            const testArray = [];
            //testArray.forE
            //testSet.forEach()
            // //testMap
            let arrayOrigType = "ARRAY";
            try {
                /** if this has a forEach method and not an array, convert it to an array for parsing */
                if (_.isArray(obj) === false && obj.forEach != null && typeof (obj.forEach) === "function") {
                    arrayOrigType = reflection.getTypeName(obj);
                    const tempArray = [];
                    obj.forEach((val, key) => {
                        if (val === key || key === obj) {
                            //if no key, just push val
                            tempArray.push(val);
                        }
                        else {
                            tempArray.push({ key, val });
                        }
                    });
                    obj = tempArray;
                }
            }
            catch (_a) {
                //eat errors
            }
            //if there are symbols present, convert those to keys that can be inspected.
            const symbols = Object.getOwnPropertySymbols(obj);
            if (symbols != null && symbols.length > 0) {
                obj = _.clone(obj);
                for (let i = 0; i < symbols.length; i++) {
                    obj[symbols[i].toString()] = obj[symbols[i]];
                    // tslint:disable-next-line: no-dynamic-delete
                    delete obj[symbols[i]];
                }
            }
            //recursivly walk children			
            if (_.isArray(obj) === true) {
                const objArray = obj;
                const toReturn = [];
                if (objArray.length <= myOptions.maxArrayElements) {
                    //output all
                    for (let i = 0; i < objArray.length; i++) {
                        toReturn.push(_inspectParse_internal(objArray[i], myOptions, seenObjects, i.toString()));
                    }
                }
                else {
                    //output top and bottom
                    //top half
                    const halfMax = Math.round(myOptions.maxArrayElements / 2);
                    for (let i = 0; i < halfMax; i++) {
                        toReturn.push(_inspectParse_internal(objArray[i], myOptions, seenObjects, i.toString()));
                    }
                    //missing middle
                    toReturn.push(`[${arrayOrigType}_TRUNCATED len=${objArray.length}]`);
                    //bottom half
                    for (let i = 0; i < halfMax; i++) {
                        const index = objArray.length - halfMax + i;
                        if (index < objArray.length) {
                            toReturn.push(_inspectParse_internal(objArray[index], myOptions, seenObjects, index.toString()));
                        }
                    }
                }
                // for ( let i = 0; i < objArray.length && i < maxArrayElements; i++ ) {
                // 	toReturn.push( inspect( objArray[ i ], maxDepth, maxArrayElements, summarizeLength ) );
                // }
                // if ( objArray.length > maxArrayElements ) {
                // 	toReturn.push( `*maxArrayElements reached.  len=${ objArray.length }*` );
                // }
                return toReturn;
            }
            else {
                //loop through object
                const functs = [];
                const toReturn = {};
                _.forIn(obj, (value, key) => {
                    const val = _inspectParse_internal(value, myOptions, seenObjects, key);
                    //reduce verbosity of functions in the object
                    if (myOptions.aggrigateFunctions === true && (typeof val === "string") && val.indexOf("[FUNCTION") === 0) {
                        const results = /^\[FUNCTION\s*([\S\s]{1,})\]$/.exec(val);
                        if (results != null) {
                            const funcDetails = results[1];
                            if (funcDetails.indexOf(key) === 0) {
                                //name of func is name as key, so don't display the redundant key
                                functs.push(results[1]);
                            }
                            else {
                                //function name is different display key
                                functs.push(`${key}=${results[1]}`);
                            }
                        }
                        else {
                            //didnt' work, report it normally
                            toReturn[key] = val;
                        }
                    }
                    else {
                        toReturn[key] = val;
                    }
                });
                if (functs.length > 0) {
                    toReturn[`[FUNCTIONS count=${functs.length}]`] = functs.join(", ");
                }
                if (myOptions.hideTypeNames !== true) {
                    const typeName = reflection.getTypeName(obj);
                    if (typeName !== "Object") {
                        toReturn["[TYPENAME]"] = typeName;
                    }
                }
                return toReturn;
            }
        }
        catch (_err) {
            const err = exception.toError(_err);
            return `[ERROR_PARSING name="${err.name}", message="${stringHelper.summarize(err.message, myOptions.summarizeLength)}"]`;
        }
    } //end fcn
    /** replace a branch of your JSON object.  good for pruning nested hiearchies, for example when wanting to decrease verbosity sent to user (before doing a JSON.stringify() )
        *
        * works on array children too
    *
    * @example
    let tree = { a:[{aa:0, ab:1}], b:{ ba:"hi", bb:"there"}};
    replaceNodes(tree, ["a.aa", "b.ba"],"*REMOVED*");
    // tree = {a[aa:"*REMOVED*",ab:1], b:{ ba:"*REMOVED", bb:"there"}};
        */
    function replaceNodes(targetObject, 
    /** example:  'a.b.c.d' will remove the d node, replacing it (with null by default, effectively deleting)*/
    nodeHiearchyStrings, replaceWith = null, replaceEmptyLeafNodes = false) {
        /** recursive helper for walking through the current hiearchy, replacing as it goes*/
        function currentNodeProcessor(previousNode, nodeName, hiearchyIndex, hiearchy) {
            if (previousNode == null || _.isString(previousNode)) {
                //if our previous node is null (or a string), nothing to do.
                return;
            }
            if (hiearchyIndex === (hiearchy.length - 1)) {
                //the node is the last node in our hiearchy,
                //so we are on the node to remove.remove it and we are done
                if (previousNode[nodeName] != null || replaceEmptyLeafNodes === true) {
                    previousNode[nodeName] = replaceWith;
                }
                return;
            }
            //walk down the hiearchy
            const thisNode = previousNode[nodeName];
            const nextHiearchyIndex = hiearchyIndex + 1;
            const nextNodeName = hiearchy[nextHiearchyIndex];
            if (_.isArray(thisNode) === true && _.isString(thisNode) === false) {
                //walk each element in the array automatically
                _.forEach(thisNode, (element) => {
                    currentNodeProcessor(element, nextNodeName, nextHiearchyIndex, hiearchy);
                });
                return;
            }
            else {
                currentNodeProcessor(thisNode, nextNodeName, nextHiearchyIndex, hiearchy);
            }
        }
        //loop through all nodeHiearchyStrings to remove, removing the leaf.
        _.forEach(nodeHiearchyStrings, (hiearchyString) => {
            if (hiearchyString == null) {
                return;
            }
            const hiearchy = hiearchyString.split(".");
            if (hiearchy.length < 1) {
                return;
            }
            currentNodeProcessor(targetObject, hiearchy[0], 0, hiearchy);
        });
    }
    jsonX.replaceNodes = replaceNodes;
})(jsonX = exports.jsonX || (exports.jsonX = {}));
/** constructor for async functions.
 * from: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/AsyncFunction
 */
const AsyncFunction = Object.getPrototypeOf(async function () { }).constructor;
/** deseralize a function that was serialized via ```.toString()```.  Works on lambda functions also. */
function parseFunction(fcnStr) {
    //citation: https://gist.github.com/lamberta/3768814  but then heavily modified for proper lambda support
    fcnStr = fcnStr.trim();
    //! handle possible async function
    let FcnCtor = Function;
    if (fcnStr.startsWith("async")) {
        fcnStr = stringHelper.removePrefix(fcnStr, "async");
        fcnStr = fcnStr.trim();
        FcnCtor = AsyncFunction;
    }
    if (fcnStr.startsWith("function")) {
        const fn_body_idx = fcnStr.indexOf("{");
        const fn_body = fcnStr.substring(fn_body_idx + 1, fcnStr.lastIndexOf("}")).trim();
        const fn_declare = fcnStr.substring(0, fn_body_idx);
        const fn_params_start = fn_declare.indexOf("(") + 1;
        const fn_params = fn_declare.substring(fn_params_start, fn_declare.lastIndexOf(")"));
        const args = fn_params.split(",");
        args.push(fn_body);
        const toReturn = new FcnCtor(...args);
        return toReturn;
    }
    else {
        //lambda
        const fn_params = fcnStr.substring(fcnStr.indexOf("(") + 1, fcnStr.indexOf(")"));
        const args = fn_params.split(",");
        let fn_body_idx = fcnStr.indexOf("=>") + 2;
        let fn_body_end = fcnStr.length;
        if (fcnStr.endsWith("}")) {
            //enclosed lambda body so remove surrounding braces
            fn_body_idx = fcnStr.indexOf("{", fn_body_idx) + 1;
            fn_body_end--;
            const fn_body = fcnStr.substring(fn_body_idx, fn_body_end);
            args.push(fn_body);
        }
        else {
            const fn_body = "return " + fcnStr.substring(fn_body_idx, fn_body_end);
            args.push(fn_body);
        }
        const toReturn = new FcnCtor(...args);
        return toReturn;
    }
}
exports.parseFunction = parseFunction;
//# sourceMappingURL=serialization.js.map