"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.from = exports.toBuffer = exports.toUint8Array = void 0;
const ex = __importStar(require("./exception"));
function fromUint8Array(uint8Array) {
    const view = new DataView(uint8Array.buffer);
    const bl = view.byteLength, largeLength = bl - (bl % 4);
    let hesStr = "", d = 0;
    for (; d < largeLength; d += 4) {
        hesStr += ("00000000" + view.getUint32(d).toString(16)).slice(-8);
    }
    for (; d < bl; d++) {
        const c = view.getUint8(d).toString(16);
        hesStr += c.length < 2 ? "0" + c : c;
    }
    return hesStr;
}
function toUint8Array(hexStr) {
    if (hexStr.length % 2)
        throw new ex.XlibException("invalid hex:" + hexStr);
    const sl = hexStr.length, largeLength = sl - (sl % 8);
    const uint8Array = new Uint8Array(sl / 2);
    const view = new DataView(uint8Array.buffer);
    let s = 0;
    for (; s < largeLength; s += 8) {
        view.setUint32(s / 8, parseInt(hexStr.substr(s, 8), 16));
    }
    for (; s < sl; s += 2) {
        view.setUint8(s / 2, parseInt(hexStr.substr(s, 2), 16));
    }
    return uint8Array;
}
exports.toUint8Array = toUint8Array;
function fromBuffer(buffer) {
    return fromUint8Array(new Uint8Array(buffer));
}
function toBuffer(hexStr) {
    return toUint8Array(hexStr).buffer;
}
exports.toBuffer = toBuffer;
function from(arrayOrBuffer) {
    if (arrayOrBuffer instanceof Uint8Array) {
        return fromUint8Array(arrayOrBuffer);
    }
    return fromBuffer(arrayOrBuffer);
}
exports.from = from;
exports.default = {
    from,
    //fromUint8Array,
    toUint8Array,
    //fromBuffer,
    toBuffer
};
//# sourceMappingURL=hex.js.map